use identifier::Identifier;
use serde::{Deserialize, Serialize};
use tag::Tag;

pub mod block_state;
pub mod color;
pub mod datapack;
pub mod identifier;
pub mod item_stack;
pub mod particle;
pub mod registry;
pub mod tag;
pub mod text_component;

#[derive(Debug, Serialize, Deserialize, Clone, Eq, PartialEq)]
#[serde(untagged)]
pub enum Either<A, B> {
    Left(A),
    Right(B),
}

#[derive(Debug, Serialize, Deserialize, Clone, Eq, PartialEq)]
#[serde(untagged)]
pub enum OneOrMany<T> {
    One(T),
    Many(Vec<T>),
}

#[derive(Debug, Serialize, Deserialize, Clone, Eq, PartialEq)]
#[serde(untagged)]
pub enum TagOrIdentifier {
    Tag(Tag),
    Identifier(Identifier),
}
